##########################################################################################
# BAYESIAN ORDINATIO AND REGRESSION ANALYSIS
##########################################################################################

require(boral)

Nburn1 <- 40000
Niter1 <- 50000
Nthin1 <- 100
nSampls <- (Niter1-Nburn1)/Nthin1

mcmcControl1 <- list(n.burnin=Nburn1,
				     n.iteration=Niter1,
				     n.thin=Nthin1,
				     seed=17)

if (MCMC2) {
	mcmcControl1$seed <- 19
}
mcmcControl2 <- mcmcControl1

#if (sz > 1) {
#	if (d==1) {
#		Niter2<-20000
#		Nthin2<-5
#		Nburn2	<- Niter2-(nSampls*Nthin2)
#		
#	}
#	if (d==2 | d==4) {
#		Niter2<-50000
#		Nthin2<-10
#		Nburn2	<- Niter2-(nSampls*Nthin2)
#	}
#	if (d==3) {
#		Niter2<-18000
#		Nthin2<-5
#		Nburn2	<- Niter2-(nSampls*Nthin2)
#	}
#	if (d==5) {
#		Niter2<-11000
#		Nthin2<-5
#		Nburn2	<- Niter2-(nSampls*Nthin2)
#	}
#	mcmcControl2$n.burnin <- Nburn2
#	mcmcControl2$n.iteration <- Niter2
#	mcmcControl2$thin <- Nthin2
#	
#	if (MCMC2) {
#		mcmcControl2$seed <- 9
#	}
#}


##########################################################################################

for (j in 1:3) {

	if (j==1) { sT<-Sys.time() }
	dir.create(file.path(FD,
						 set_no,
						 paste0("boralModel1",
						 	   "_d",
						 	   j,
						 	   "_sz",
						 	   sz)))
	setwd(file.path(FD,
					set_no,
					paste0("boralModel1","_d",j,"_sz",sz)))
					
	brl1	<-	boral(y=y_train[[j]], 
					  X=x_train[[j]][,-1], 
					  num.lv=0,
			  		  family = "binomial", 
			  		  calc.ics = FALSE, 
			  		  mcmc.control=mcmcControl1, 
			  		  save.model = TRUE)

	setwd(WD)
	if (j==1) { 
		eT<-Sys.time()
		comTimes<-eT-sT
	}	
	
	filebody <- paste0("brl1_", j, "_", dataN[sz])
	filebody_comtim <- paste0("comTimes_BORAL1_",dataN[sz])
	
	if (MCMC2) {
		filebody <- paste0(filebody, "_MCMC2")
		filebody_comtim <- paste0(filebody, "_MCMC2")
	}
		
	save(brl1, file=file.path(FD,
							  set_no,
							  paste0(filebody, ".RData")))

	if (j==1) {
		save(comTimes, file=file.path(FD,
									  set_no,
									  paste0(filebody_comtim,
											 ".RData")))
	}

	if (j==1) { sT <- Sys.time() }
	dir.create(file.path(FD,
	                     set_no,
	                     paste0("boralModel2",
	                            "_d",
	                            j,
	                            "_sz",
	                            sz)))
	setwd(file.path(FD,
					set_no,
					paste0("boralModel2",
						  "_d",
						  j,
						  "_sz",
						  sz)))
						  
	brl2	<-	boral(y=y_train[[j]], 
					  X=x_train[[j]][,-1], 
					  num.lv=2, 
			  		  family = "binomial", 
			  		  calc.ics = FALSE,
			  		  mcmc.control=mcmcControl2, 
			  		  save.model = TRUE)
	setwd(WD)

	if (j==1) { 
		eT<-Sys.time()
		comTimes<-eT-sT
		}

	filebody <- paste0("brl2_", j, "_", dataN[sz])
	filebody_comtim <- paste0("comTimes_BORAL2_", dataN[sz])

	if (MCMC2) {
		filebody <- paste0(filebody, "_MCMC2") 	
		filebody_comtim <- paste0(filebody_comtim, "_MCMC2") 	
	}
	
	save(brl2, file=file.path(FD,
							  set_no,
							  paste0(filebody,".RData",sep="")))
	if (j==1) {
		save(comTimes, file=file.path(FD,
									  set_no,
									  paste0(filebody_comtim,".RData")))
	}

}
